// Depends on https://raw.github.com/mozilla-comm/ical.js/master/build/ical.js

function ical_events(ical, event_callback, recur_event_callback) {
    jcal_events(ICAL.parse(ical), event_callback, recur_event_callback);
}

function jcal_events(jcal, event_callback, recur_event_callback) {
    var arr = new ICAL.Component(jcal).getAllSubcomponents('vevent');

		arr.forEach(function (element, index) {
    	if (element.hasProperty('rrule')) {
            recur_event_callback(element);
        } else {
            event_callback(element);
        }
		});
}

function event_duration(event) {
    if(event.getFirstPropertyValue('dtend'))
	{
		return new Date(event.getFirstPropertyValue('dtend').toJSDate() - event.getFirstPropertyValue('dtstart').toJSDate()).getTime();
	} else {
		event.updatePropertyWithValue('dtend', event.getFirstPropertyValue('dtstart'));
		return new Date(event.getFirstPropertyValue('dtstart').toJSDate().getTime()+86400000);
	}
}

function event_dtend(dtstart, duration) {
    return new ICAL.Time().fromJSDate(new Date(dtstart.toJSDate().getTime() + duration));
}

function expand_recur_event(event, dtstart, dtend, event_callback) {
    var exp = new ICAL.RecurExpansion({
        component:event,
        dtstart:event.getFirstPropertyValue('dtstart')
    });
    var duration = event_duration(event);
    while (! exp.complete && exp.next() < dtend) {
        if (exp.last >= dtstart) {
            event = new ICAL.Component(event.toJSON());
            event.updatePropertyWithValue('dtstart', exp.last);
            event.updatePropertyWithValue('dtend', event_dtend(exp.last, duration));
            event_callback(event);
        }
    }
}
