"use strict";

function depends_example() {
    var deps = [];
    return deps;
}

var Modul_dwdopendata = function () {
	
    // privat sub function
    function createHtml(elem) {
		var html = "";
		var count = elem.getReading('get').val;
		if (count >= 1) {
			if (count > elem.data('max')) {
				count = elem.data('max');
			}
			for (var i = 0; i <= count - 1; i++) {
				html += "<div class=\"cell top-space\">";
				
				if (elem.getReading('a_' + i + '_urgency').val == "Immediate") {
					html += "<div class=\"\" style=\"min-width:150px;display:inline-block;padding:4px;font-weight:bold;color:#222222;border-radius:4px;background-color:rgb(" + elem.getReading('a_' + i + '_areaColor').val + ");\"><i class=\"fa fa-exclamation-triangle\" style=\"color:firebrick;\"></i>&nbsp;&nbsp;&nbsp;" + elem.getReading('a_' + i + '_eventDesc').val + "&nbsp;&nbsp;&nbsp;<i class=\"fa fa-exclamation-triangle\" style=\"color:firebrick;\"></i></div>";
				}
				else if (elem.getReading('a_' + i + '_urgency').val == "Future") {
					html += "<div class=\"\" style=\"min-width:150px;display:inline-block;padding:4px;font-weight:bold;color:#222222;border-radius:4px;background-color:rgb(" + elem.getReading('a_' + i + '_areaColor').val + ");\"><i class=\"fa fa-info-circle\" style=\"color:#0088CC;\"></i>&nbsp;&nbsp;&nbsp;" + elem.getReading('a_' + i + '_eventDesc').val + "&nbsp;&nbsp;&nbsp;<i class=\"fa fa-info-circle\" style=\"color:#0088CC;\"></i></div>";
				}
				if (elem.data('region')) {
					html += "<div class=\"cell\">" + elem.getReading('a_' + i + '_areaDesc').val + "</div>";
				}
				
				if (elem.data('description')) {
					html += "<div class=\"cell\">" + elem.getReading('a_' + i + '_description').val + "</div>";
				}
				
				if (elem.data('instructions')) {
					if (ftui.isValid(elem.getReading('a_' + i + '_instruction').val)) {
						html += "<div class=\"cell\">" + elem.getReading('a_' + i + '_instruction').val + "</div>";
					}
				}
				
				if (elem.data('timerange')) {
					if (ftui.isValid(elem.getReading('a_' + i + '_onset').val) && ftui.isValid(elem.getReading('a_' + i + '_expires').val)) {
						html += "<div class=\"cell\">Von: " + elem.getReading('a_' + i + '_onset').val.toDate().ddmm() + " " + elem.getReading('a_' + i + '_onset').val.toDate().hhmm() + " bis: " + elem.getReading('a_' + i + '_expires').val.toDate().ddmm() + " " + elem.getReading('a_' + i + '_expires').val.toDate().hhmm() + "</div>";
					}
				}
				
				html += "</div>";
			}
		}
		else {
			html += "<div class=\"cell top-space\" style=\"min-width:150px;display:inline-block;padding:3px;color:#DDDDDD;border-radius:4px;background-color:#32A054;\">Aktuell keine Warnmeldungen vorhanden.</div>";
		}
		elem.html(html);
    }

    function init() {
        me.elements = $('div[data-type="' + me.widgetname + '"]:not([data-ready])', me.area);
        me.elements.each(function (index) {
            var elem = $(this);
            elem.attr("data-ready", "");
			
			elem.initData('get',		'a_count');
			elem.initData('max',			10);
			elem.initData('description',	true)
			elem.initData('region',			true)
			elem.initData('instructions',	true)
			elem.initData('timerange',		true)
			
			me.addReading(elem, 'get');

			// if hide reading is defined, set defaults for comparison
			if (elem.isValidData('hide')) {
				elem.initData('hide-on', '(true|1|on)');
			}
			elem.initData('hide', elem.data('get'));
			if (elem.isValidData('hide-on')) {
				elem.initData('hide-off', '!on');
			}
			me.addReading(elem, 'hide');
			
			var count = elem.getReading('get').val;
			if (count >= 1) {
				if (count > elem.data('max')) {
					count = elem.data('max');
				}
				for (var i = 0; i <= count - 1; i++) {

					elem.initData('a_' + i + '_areaColor', 'a_' + i + '_areaColor');
					me.addReading(elem, 'a_' + i + '_areaColor');
					elem.initData('a_' + i + '_urgency', 'a_' + i + '_urgency');
					me.addReading(elem, 'a_' + i + '_urgency');
					elem.initData('a_' + i + '_eventDesc', 'a_' + i + '_eventDesc');
					me.addReading(elem, 'a_' + i + '_eventDesc');
					if (elem.data('region')) {
						elem.initData('a_' + i + '_areaDesc', 'a_' + i + '_areaDesc');
						me.addReading(elem, 'a_' + i + '_areaDesc');
					}
					if (elem.data('description')) {
						elem.initData('a_' + i + '_description', 'a_' + i + '_description');
						me.addReading(elem, 'a_' + i + '_description');
					}
					if (elem.data('instructions')) {
						elem.initData('a_' + i + '_instruction', 'a_' + i + '_instruction');
						me.addReading(elem, 'a_' + i + '_instruction');
					}
					
					if (elem.data('timerange')) {
						elem.initData('a_' + i + '_onset', 'a_' + i + '_onset');
						me.addReading(elem, 'a_' + i + '_onset');
						elem.initData('a_' + i + '_expires', 'a_' + i + '_expires');
						me.addReading(elem, 'a_' + i + '_expires');
					}
				}
			}
        });
    }
		
    function update(dev, par) {

        me.elements.filterDeviceReading('get', dev, par)
            .each(function (index) {
                var elem = $(this);
            if (elem.matchDeviceReading('get', dev, par)) {
                createHtml(elem);
            }
			me.update_hide(dev, par);
		});
	}

    // public
    // inherit all public members from base class
    var me = $.extend(new Modul_widget(), {
        //override or own public members
        widgetname: 'dwdopendata',
        init: init,
		update: update,
    });
    return me;
};